DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Member Functions | Private Attributes | Static Private Attributes | Friends | List of all members
DSRContentItem Class Reference

Interface class for content items. More...

Inheritance diagram for DSRContentItem:

## Public Member Functions
| DSRContentItem (const DSRContentItem &item)
| copy constructor. More...
virtual | ~DSRContentItem ()
| destructor
virtual OFBool | isEqual (const DSRContentItem &item) const
| check whether content items are "equal". More...
virtual OFBool | isNotEqual (const DSRContentItem &item) const
| check whether content items are "not equal". More...
OFBool | isValid () const
| check for validity/completeness. More...
OFBool | isMarked () const
| check for mark flag. More...
void | setMark (const OFBool flag)
| mark/unmark item. More...
E_ValueType | getValueType () const
| get value type. More...
E_RelationshipType | getRelationshipType () const
| get relationship type. More...
size_t | getReferencedNodeID () const
| get ID of the referenced node. More...
const OFString & | getStringValue () const
| get string value. More...
OFCondition | setStringValue (const OFString &stringValue, const OFBool check=OFTrue)
| set string value. More...
DSRCodedEntryValue * | getCodeValuePtr ()
| get pointer to code value. More...
const DSRCodedEntryValue & | getCodeValue () const
| get code value. More...
OFCondition | getCodeValue (DSRCodedEntryValue &codeValue) const
| get copy of code value. More...
OFCondition | setCodeValue (const DSRCodedEntryValue &codeValue, const OFBool check=OFTrue)
| set code value. More...
DSRNumericMeasurementValue * | getNumericValuePtr ()
| get pointer to numeric value. More...
const DSRNumericMeasurementValue & | getNumericValue () const
| get numeric value. More...
OFCondition | getNumericValue (DSRNumericMeasurementValue &numericValue) const
| get copy of numeric value. More...
OFCondition | setNumericValue (const DSRNumericMeasurementValue &numericValue, const OFBool check=OFTrue)
| set numeric value. More...
DSRSpatialCoordinatesValue * | getSpatialCoordinatesPtr ()
| get pointer to spatial coordinates. More...
const DSRSpatialCoordinatesValue & | getSpatialCoordinates () const
| get spatial coordinates. More...
OFCondition | getSpatialCoordinates (DSRSpatialCoordinatesValue &coordinatesValue) const
| get copy of spatial coordinates. More...
OFCondition | setSpatialCoordinates (const DSRSpatialCoordinatesValue &coordinatesValue, const OFBool check=OFTrue)
| set spatial coordinates. More...
DSRSpatialCoordinates3DValue * | getSpatialCoordinates3DPtr ()
| get pointer to spatial coordinates 3D. More...
const DSRSpatialCoordinates3DValue & | getSpatialCoordinates3D () const
| get spatial coordinates 3D. More...
OFCondition | getSpatialCoordinates3D (DSRSpatialCoordinates3DValue &coordinatesValue) const
| get copy of spatial coordinates 3D. More...
OFCondition | setSpatialCoordinates3D (const DSRSpatialCoordinates3DValue &coordinatesValue, const OFBool check=OFTrue)
| set spatial coordinates 3D. More...
DSRTemporalCoordinatesValue * | getTemporalCoordinatesPtr ()
| get pointer to temporal coordinates. More...
const DSRTemporalCoordinatesValue & | getTemporalCoordinates () const
| get temporal coordinates. More...
OFCondition | getTemporalCoordinates (DSRTemporalCoordinatesValue &coordinatesValue) const
| get copy of temporal coordinates. More...
OFCondition | setTemporalCoordinates (const DSRTemporalCoordinatesValue &coordinatesValue, const OFBool check=OFTrue)
| set temporal coordinates. More...
DSRCompositeReferenceValue * | getCompositeReferencePtr ()
| get pointer to composite reference. More...
const DSRCompositeReferenceValue & | getCompositeReference () const
| get composite reference. More...
OFCondition | getCompositeReference (DSRCompositeReferenceValue &referenceValue) const
| get copy of composite reference. More...
OFCondition | setCompositeReference (const DSRCompositeReferenceValue &referenceValue, const OFBool check=OFTrue)
| set composite reference. More...
DSRImageReferenceValue * | getImageReferencePtr ()
| get pointer to image reference. More...
const DSRImageReferenceValue & | getImageReference () const
| get image reference. More...
OFCondition | getImageReference (DSRImageReferenceValue &referenceValue) const
| get copy of image reference. More...
OFCondition | setImageReference (const DSRImageReferenceValue &referenceValue, const OFBool check=OFTrue)
| set image reference. More...
DSRWaveformReferenceValue * | getWaveformReferencePtr ()
| get pointer to waveform reference. More...
const DSRWaveformReferenceValue & | getWaveformReference () const
| get waveform reference. More...
OFCondition | getWaveformReference (DSRWaveformReferenceValue &referenceValue) const
| get copy of waveform reference. More...
OFCondition | setWaveformReference (const DSRWaveformReferenceValue &referenceValue, const OFBool check=OFTrue)
| set waveform reference. More...
E_ContinuityOfContent | getContinuityOfContent () const
| get continuity of content flag. More...
OFCondition | setContinuityOfContent (const E_ContinuityOfContent continuityOfContent, const OFBool check=OFTrue)
| set continuity of content flag. More...
OFCondition | getTemplateIdentification (OFString &templateIdentifier, OFString &mappingResource) const
| get template identifier and mapping resource. More...
OFCondition | getTemplateIdentification (OFString &templateIdentifier, OFString &mappingResource, OFString &mappingResourceUID) const
| get template identifier and mapping resource and optional mapping resource UID. More...
OFCondition | setTemplateIdentification (const OFString &templateIdentifier, const OFString &mappingResource, const OFString &mappingResourceUID="", const OFBool check=OFTrue)
| set template identifier and mapping resource. More...
DSRCodedEntryValue * | getConceptNamePtr ()
| get pointer to concept name. More...
const DSRCodedEntryValue & | getConceptName () const
| get concept name. More...
OFCondition | getConceptName (DSRCodedEntryValue &conceptName) const
| get copy of concept name. More...
OFCondition | setConceptName (const DSRCodedEntryValue &conceptName, const OFBool check=OFTrue)
| set concept name. More...
const OFString & | getObservationDateTime () const
| get observation date/time. More...
OFCondition | setObservationDateTime (const OFString &observationDateTime, const OFBool check=OFTrue)
| set observation date/time. More...
const OFString & | getObservationUID () const
| get observation unique identifier. More...
OFCondition | setObservationUID (const OFString &observationUID, const OFBool check=OFTrue)
| set observation unique identifier. More...
const OFString & | getAnnotationText () const
| get annotation text. More...
OFCondition | setAnnotationText (const OFString &annotationText) const
| set annotation text. More...

## Protected Member Functions
| DSRContentItem ()
| default constructor (protected)
void | setTreeNode (DSRDocumentTreeNode *node)
| set internal tree node pointer (protected) More...
void | swap (DSRContentItem &item)
| fast, non-throwing swap function. More...
Protected Member Functions inherited from DSRTypes
virtual | ~DSRTypes ()
| destructor. More...

## Private Attributes
DSRDocumentTreeNode * | TreeNode
| internal tree node pointer to current content item
OFBool | DeleteTreeNode
| flag indicating whether to delete the 'TreeNode' during destruction (or not)
const DSRNumericMeasurementValue | EmptyNumericMeasurement
| empty numeric measurement value. More...

## Static Private Attributes
static const OFString | EmptyString
| empty string value. More...
static const DSRCodedEntryValue | EmptyCodedEntry
| empty coded entry value. More...
static const DSRSpatialCoordinatesValue | EmptySpatialCoordinates
| empty spatial coordinates value. More...
static const DSRSpatialCoordinates3DValue | EmptySpatialCoordinates3D
| empty spatial coordinates 3D value. More...
static const DSRTemporalCoordinatesValue | EmptyTemporalCoordinates
| empty temporal coordinates value. More...
static const DSRCompositeReferenceValue | EmptyCompositeReference
| empty composite reference value. More...
static const DSRImageReferenceValue | EmptyImageReference
| empty image reference value. More...
static const DSRWaveformReferenceValue | EmptyWaveformReference
| empty waveform reference value. More...

## Friends
class | DSRDocumentSubTree

## Additional Inherited Members
Protected Types inherited from DSRTypes
enum | E_DocumentType { DT_invalid , DT_unknown = DT_invalid , DT_BasicTextSR , DT_EnhancedSR , DT_ComprehensiveSR , DT_KeyObjectSelectionDocument , DT_MammographyCadSR , DT_ChestCadSR , DT_ColonCadSR , DT_ProcedureLog , DT_XRayRadiationDoseSR , DT_EnhancedXRayRadiationDoseSR , DT_SpectaclePrescriptionReport , DT_MacularGridThicknessAndVolumeReport , DT_ImplantationPlanSRDocument , DT_Comprehensive3DSR , DT_RadiopharmaceuticalRadiationDoseSR , DT_ExtensibleSR , DT_AcquisitionContextSR , DT_SimplifiedAdultEchoSR , DT_PatientRadiationDoseSR , DT_PerformedImagingAgentAdministrationSR , DT_PlannedImagingAgentAdministrationSR , DT_RenditionSelectionDocument , DT_WaveformAnnotationSR , DT_last = DT_WaveformAnnotationSR }
| SR document types (DICOM IOD) More...
enum | E_RelationshipType { RT_invalid , RT_unknown , RT_isRoot , RT_contains , RT_hasObsContext , RT_hasAcqContext , RT_hasConceptMod , RT_hasProperties , RT_inferredFrom , RT_selectedFrom , RT_last = RT_selectedFrom }
| SR relationship types. More...
enum | E_ValueType { VT_invalid , VT_Text , VT_Code , VT_Num , VT_DateTime , VT_Date , VT_Time , VT_UIDRef , VT_PName , VT_SCoord , VT_SCoord3D , VT_TCoord , VT_Composite , VT_Image , VT_Waveform , VT_Container , VT_byReference , VT_includedTemplate , VT_last = VT_includedTemplate }
| SR value types. More...
enum | E_PresentationStateType { PT_invalid , PT_unknown = PT_invalid , PT_Grayscale , PT_Color , PT_PseudoColor , PT_Blending , PT_XAXRFGrayscale , PT_GrayscalePlanarMPR , PT_CompositingPlanarMPR , PT_AdvancedBlending , PT_VolumeRendering , PT_SegmentedVolumeRendering , PT_MultipleVolumeRendering , PT_VariableModalityLUT , PT_Waveform , PT_WaveformAcquisition , PT_last = PT_WaveformAcquisition }
| Softcopy presentation state types. More...
enum | E_GraphicType { GT_invalid , GT_unknown = GT_invalid , GT_Point , GT_Multipoint , GT_Polyline , GT_Circle , GT_Ellipse , GT_last = GT_Ellipse }
| SR graphic types. More...
enum | E_GraphicType3D { GT3_invalid , GT3_unknown = GT3_invalid , GT3_Point , GT3_Multipoint , GT3_Polyline , GT3_Polygon , GT3_Ellipse , GT3_Ellipsoid , GT3_last = GT3_Ellipsoid }
| SR graphic types (3D). More...
enum | E_TemporalRangeType { TRT_invalid , TRT_unknown = TRT_invalid , TRT_Point , TRT_Multipoint , TRT_Segment , TRT_Multisegment , TRT_Begin , TRT_End , TRT_last = TRT_End }
| SR temporal range types. More...
enum | E_ContinuityOfContent { COC_invalid , COC_Separate , COC_Continuous , COC_last = COC_Continuous }
| SR continuity of content flag. More...
enum | E_PreliminaryFlag { PF_invalid , PF_Preliminary , PF_Final , PF_last = PF_Final }
| SR document preliminary flag. More...
enum | E_CompletionFlag { CF_invalid , CF_Partial , CF_Complete , CF_last = CF_Complete }
| SR document completion flag. More...
enum | E_VerificationFlag { VF_invalid , VF_Unverified , VF_Verified , VF_last = VF_Verified }
| SR document verification flag. More...
enum | E_CharacterSet { CS_invalid , CS_unknown = CS_invalid , CS_ASCII , CS_default = CS_ASCII , CS_Latin1 , CS_Latin2 , CS_Latin3 , CS_Latin4 , CS_Cyrillic , CS_Arabic , CS_Greek , CS_Hebrew , CS_Latin5 , CS_Latin9 , CS_Thai , CS_Japanese , CS_Korean , CS_ChineseISO , CS_ChineseGB18030 , CS_ChineseGBK , CS_UTF8 , CS_last = CS_UTF8 }
| Specific character set. More...
enum | E_CodeValueType { CVT_auto , CVT_Short , CVT_Long , CVT_URN }
| Code value type. More...
enum | E_AddMode { AM_afterCurrent , AM_beforeCurrent , AM_belowCurrent , AM_belowCurrentBeforeFirstChild }
| Add node mode. More...
Static Protected Member Functions inherited from DSRTypes
static const char * | documentTypeToSOPClassUID (const E_DocumentType documentType)
| convert SR document type to SOP class UID More...
static const char * | documentTypeToModality (const E_DocumentType documentType)
| convert SR document type to modality More...
static const char * | documentTypeToReadableName (const E_DocumentType documentType)
| convert SR document type to readable name. More...
static const char * | documentTypeToDocumentTitle (const E_DocumentType documentType, OFString &documentTitle)
| convert SR document type to document title. More...
static OFBool | requiresEnhancedEquipmentModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Enhanced General Equipment Module More...
static OFBool | requiresTimezoneModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Timezone Module More...
static OFBool | requiresSynchronizationModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Synchronization Module More...
static OFBool | usesSRDocumentSeriesModule (const E_DocumentType documentType)
| check whether a given SR document type uses the SR Document Series Module (instead of the Key Object Document Series Module) More...
static OFBool | usesKeyObjectDocumentSeriesModule (const E_DocumentType documentType)
| check whether a given SR document type uses the Key Object Document Series Module (instead of the SR Document Series Module) More...
static OFBool | usesSRDocumentGeneralModule (const E_DocumentType documentType)
| check whether a given SR document type uses the SR Document General Module (instead of the Key Object Document Module) More...
static OFBool | usesKeyObjectDocumentModule (const E_DocumentType documentType)
| check whether a given SR document type uses the Key Object Document Module (instead of the SR Document General Module) More...
static const char * | relationshipTypeToDefinedTerm (const E_RelationshipType relationshipType)
| convert relationship type to DICOM defined term More...
static const char * | relationshipTypeToReadableName (const E_RelationshipType relationshipType)
| convert relationship type to readable name. More...
static const char * | valueTypeToDefinedTerm (const E_ValueType valueType)
| convert value type to DICOM defined term More...
static const char * | valueTypeToXMLTagName (const E_ValueType valueType)
| convert value type to XML tag name More...
static const char * | valueTypeToReadableName (const E_ValueType valueType)
| convert value type to readable name. More...
static const char * | presentationStateTypeToShortName (const E_PresentationStateType pstateType)
| convert presentation state type to short name. More...
static const char * | graphicTypeToEnumeratedValue (const E_GraphicType graphicType)
| convert graphic type to DICOM enumerated value More...
static const char * | graphicTypeToReadableName (const E_GraphicType graphicType)
| convert graphic type to readable name. More...
static const char * | graphicType3DToEnumeratedValue (const E_GraphicType3D graphicType)
| convert graphic type (3D) to DICOM enumerated value More...
static const char * | graphicType3DToReadableName (const E_GraphicType3D graphicType)
| convert graphic type (3D) to readable name. More...
static const char * | temporalRangeTypeToEnumeratedValue (const E_TemporalRangeType temporalRangeType)
| convert temporal range type to DICOM enumerated value More...
static const char * | temporalRangeTypeToReadableName (const E_TemporalRangeType temporalRangeType)
| convert temporal range type to readable name. More...
static const char * | continuityOfContentToEnumeratedValue (const E_ContinuityOfContent continuityOfContent)
| convert continuity of content flag to DICOM enumerated value More...
static const char * | preliminaryFlagToEnumeratedValue (const E_PreliminaryFlag preliminaryFlag)
| convert preliminary flag to DICOM enumerated value More...
static const char * | completionFlagToEnumeratedValue (const E_CompletionFlag completionFlag)
| convert completion flag to DICOM enumerated value More...
static const char * | verificationFlagToEnumeratedValue (const E_VerificationFlag verificationFlag)
| convert verification flag to DICOM enumerated value More...
static const char * | characterSetToDefinedTerm (const E_CharacterSet characterSet)
| convert character set to DICOM defined term More...
static const char * | characterSetToHTMLName (const E_CharacterSet characterSet)
| convert character set to HTML name. More...
static const char * | characterSetToXMLName (const E_CharacterSet characterSet)
| convert character set to XML name. More...
static E_DocumentType | sopClassUIDToDocumentType (const OFString &sopClassUID)
| convert SOP class UID to SR document type More...
static E_RelationshipType | definedTermToRelationshipType (const OFString &definedTerm)
| convert DICOM defined term to relationship type More...
static E_ValueType | definedTermToValueType (const OFString &definedTerm)
| convert DICOM defined term to value type More...
static E_PresentationStateType | sopClassUIDToPresentationStateType (const OFString &sopClassUID)
| convert SOP class UID to presentation state type More...
static E_ValueType | xmlTagNameToValueType (const OFString &xmlTagName)
| convert XML tag name to value type More...
static E_GraphicType | enumeratedValueToGraphicType (const OFString &enumeratedValue)
| convert DICOM enumerated value to graphic type More...
static E_GraphicType3D | enumeratedValueToGraphicType3D (const OFString &enumeratedValue)
| convert DICOM enumerated value to graphic type (3D) More...
static E_TemporalRangeType | enumeratedValueToTemporalRangeType (const OFString &enumeratedValue)
| convert DICOM enumerated value to temporal range type More...
static E_ContinuityOfContent | enumeratedValueToContinuityOfContent (const OFString &enumeratedValue)
| convert DICOM enumerated value to continuity of content flag More...
static E_PreliminaryFlag | enumeratedValueToPreliminaryFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to preliminary flag More...
static E_CompletionFlag | enumeratedValueToCompletionFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to completion flag More...
static E_VerificationFlag | enumeratedValueToVerificationFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to verification flag More...
static E_CharacterSet | definedTermToCharacterSet (const OFString &definedTerm)
| convert DICOM defined term to character set. More...
static OFBool | isDocumentTypeSupported (const E_DocumentType documentType)
| check whether specified SR document type is supported by this library More...
static const OFString & | currentDate (OFString &dateString)
| get current date in DICOM 'DA' format. More...
static const OFString & | currentTime (OFString &timeString)
| get current time in DICOM 'TM' format. More...
static const OFString & | currentDateTime (OFString &dateTimeString)
| get current date and time in DICOM 'DT' format. More...
static const OFString & | localTimezone (OFString &timezoneString)
| get local timezone in DICOM format. More...
static const OFString & | dicomToReadableDate (const OFString &dicomDate, OFString &readableDate)
| convert DICOM date string to readable format. More...
static const OFString & | dicomToReadableTime (const OFString &dicomTime, OFString &readableTime)
| convert DICOM time string to readable format. More...
static const OFString & | dicomToReadableDateTime (const OFString &dicomDateTime, OFString &readableDateTime)
| convert DICOM date time string to readable format. More...
static const OFString & | dicomToReadablePersonName (const OFString &dicomPersonName, OFString &readablePersonName)
| convert DICOM person name to readable format. More...
static const OFString & | dicomToXMLPersonName (const OFString &dicomPersonName, OFString &xmlPersonName, const OFBool writeEmptyValue=OFFalse)
| convert DICOM person name to XML format. More...
static const char * | numberToString (const size_t number, char *stringValue, size_t stringLength)
| convert unsigned integer number to character string More...
static size_t | stringToNumber (const char *stringValue)
| convert string to unsigned integer number More...
static const OFString & | convertToPrintString (const OFString &sourceString, OFString &printString)
| convert character string to print string. More...
static const OFString & | convertToHTMLString (const OFString &sourceString, OFString &markupString, const size_t flags=0, const OFBool newlineAllowed=OFFalse)
| convert character string to HTML mnenonic string. More...
static const OFString & | convertToXMLString (const OFString &sourceString, OFString &markupString)
| convert character string to XML mnenonic string. More...
static OFBool | checkForValidReference (const OFString &stringValue)
| check string for valid reference (as used for by-reference relationships). More...
static DSRIODConstraintChecker * | createIODConstraintChecker (const E_DocumentType documentType)
| create specified SR IOD content relationship constraint checker object. More...
static DSRDocumentTreeNode * | createDocumentTreeNode (const E_RelationshipType relationshipType, const E_ValueType valueType)
| create specified document tree node. More...
static OFCondition | addElementToDataset (OFCondition &result, DcmItem &dataset, DcmElement *delem, const OFString &vm, const OFString &type, const char *moduleName=NULL)
| add given element to the dataset. More...
static void | removeAttributeFromSequence (DcmSequenceOfItems &sequence, const DcmTagKey &tagKey)
| remove given attribute from the sequence. More...
static OFCondition | getElementFromDataset (DcmItem &dataset, DcmElement &delem)
| get element from dataset More...
static const char * | getStringValueFromElement (const DcmElement &delem)
| get string value from element More...
static const OFString & | getStringValueFromElement (const DcmElement &delem, OFString &stringValue)
| get string value from element. More...
static OFCondition | getStringValueFromElement (const DcmElement &delem, OFString &stringValue, const signed long pos)
| get string value from element More...
static const OFString & | getPrintStringFromElement (const DcmElement &delem, OFString &stringValue)
| get string value from element and convert to "print" format. More...
static const OFString & | getMarkupStringFromElement (const DcmElement &delem, OFString &stringValue, const OFBool convertNonASCII=OFFalse)
| get string value from element and convert to HTML/XML. More...
static OFCondition | getStringValueFromDataset (DcmItem &dataset, const DcmTagKey &tagKey, OFString &stringValue, const signed long pos=0)
| get string value from dataset More...
static OFCondition | putStringValueToDataset (DcmItem &dataset, const DcmTag &tag, const OFString &stringValue, const OFBool allowEmpty=OFTrue)
| put string value to dataset More...
static OFBool | checkElementValue (DcmElement *delem, const DcmTagKey &tagKey, const OFString &vm, const OFString &type, const OFCondition &searchCond=EC_Normal, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| check element value for correct value multiplicity and type. More...
static OFBool | checkElementValue (DcmElement &delem, const OFString &vm, const OFString &type, const OFCondition &searchCond=EC_Normal, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| check element value for correct value multiplicity and type. More...
static OFCondition | getAndCheckElementFromDataset (DcmItem &dataset, DcmElement &delem, const OFString &vm, const OFString &type, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| get element from dataset and check it for correct value multiplicity and type. More...
static OFCondition | getAndCheckStringValueFromDataset (DcmItem &dataset, const DcmTagKey &tagKey, OFString &stringValue, const OFString &vm, const OFString &type, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| get string value from dataset and check it for correct value multiplicity and type. More...
static void | printInvalidContentItemMessage (const char *action, const DSRDocumentTreeNode *node, const char *location=NULL)
| print the warning message that the current content item is invalid/incomplete. More...
static void | printContentItemErrorMessage (const char *action, const OFCondition &result, const DSRDocumentTreeNode *node, const char *location=NULL)
| print an error message for the current content item. More...
static void | printUnknownValueWarningMessage (const char *valueName, const char *readValue=NULL, const char *action="Reading")
| print a warning message that an unknown/unsupported value has been determined More...
static OFBool | writeStringValueToXML (STD_NAMESPACE ostream &stream, const OFString &stringValue, const OFString &tagName, const OFBool writeEmptyValue=OFFalse)
| write string value to XML output stream. More...
static OFBool | writeStringFromElementToXML (STD_NAMESPACE ostream &stream, DcmElement &delem, const OFString &tagName, const OFBool writeEmptyValue=OFFalse)
| write string value from DICOM element to XML output stream. More...
static size_t | createHTMLAnnexEntry (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &annexStream, const OFString &referenceText, size_t &annexNumber, const size_t flags=0)
| create an HTML annex entry with hyperlinks. More...
static size_t | createHTMLFootnote (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &footnoteStream, size_t &footnoteNumber, const size_t nodeID, const size_t flags=0)
| create an HTML footnote with hyperlinks More...
static OFCondition | appendStream (STD_NAMESPACE ostream &mainStream, OFOStringStream &tempStream, const char *heading=NULL)
| append one output stream to another. More...
Static Protected Attributes inherited from DSRTypes
static const size_t | RF_readDigitalSignatures
| read digital signatures from dataset
static const size_t | RF_acceptUnknownRelationshipType
| accept unknown/missing relationship type
static const size_t | RF_acceptInvalidContentItemValue
| accept invalid content item value (e.g. violation of VR or VM definition)
static const size_t | RF_ignoreRelationshipConstraints
| ignore relationship constraints for this document class
static const size_t | RF_ignoreContentItemErrors
| do not abort on content item errors (e.g. missing value type specific attributes)
static const size_t | RF_skipInvalidContentItems
| do not abort when detecting an invalid content item, skip invalid sub-tree instead
static const size_t | RF_showCurrentlyProcessedItem
| show the currently processed content item (e.g. "1.2.3")
static const size_t | HF_neverExpandChildrenInline
| external: never expand child nodes inline
static const size_t | HF_alwaysExpandChildrenInline
| external: always expand child nodes inline
static const size_t | HF_renderInlineCodes
| external: render codes even if they appear inline
static const size_t | HF_useCodeDetailsTooltip
| external: render code details as a tooltip (not with HTML 3.2)
static const size_t | HF_renderConceptNameCodes
| external: render concept name codes (default: code meaning only)
static const size_t | HF_renderNumericUnitCodes
| external: render the code of the numeric measurement unit
static const size_t | HF_useCodeMeaningAsUnit
| external: use code meaning for the numeric measurement unit (default: code value)
static const size_t | HF_renderPatientTitle
| external: use patient information as document title (default: document type)
static const size_t | HF_renderNoDocumentHeader
| external: render no general document information (header)
static const size_t | HF_renderDcmtkFootnote
| external: render dcmtk/dcmsr comment at the end of the document
static const size_t | HF_renderFullData
| external: render the full data of all content items
static const size_t | HF_renderSectionTitlesInline
| external: render section titles inline (default: separate paragraph)
static const size_t | HF_copyStyleSheetContent
| external: copy Cascading Style Sheet (CSS) content to HTML file
static const size_t | HF_HTML32Compatibility
| external: output compatible to HTML version 3.2 (default: 4.01)
static const size_t | HF_XHTML11Compatibility
| external: output compatible to XHTML version 1.1 (default: HTML 4.01)
static const size_t | HF_addDocumentTypeReference
| external: add explicit reference to HTML document type (DTD)
static const size_t | HF_omitGeneratorMetaElement
| external: omit generator meta element referring to the DCMTK
static const size_t | HF_renderItemsSeparately
| internal: render items separately (for container with SEPARATE flag)
static const size_t | HF_renderItemInline
| internal: expand items inline when they are short and have no child nodes
static const size_t | HF_currentlyInsideAnnex
| internal: content item is rendered fully inside the annex
static const size_t | HF_createFootnoteReferences
| internal: create footnote references
static const size_t | HF_convertNonASCIICharacters
| internal: convert non-ASCII characters (> #127) to &#nnn;
static const size_t | HF_renderAllCodes
| shortcut: render all codes
static const size_t | HF_internalUseOnly
| shortcut: filter all flags that are only used internally
static const size_t | XF_writeEmptyTags
| write: write all tags even if their value is empty
static const size_t | XF_writeTemplateIdentification
| write: write template identification information (TID and mapping resource)
static const size_t | XF_alwaysWriteItemIdentifier
| write: always write item identifier "id", not only when item is referenced
static const size_t | XF_codeComponentsAsAttribute
| write: encode code value, coding scheme designator and coding scheme version as attribute instead of element text
static const size_t | XF_relationshipTypeAsAttribute
| write: encode relationship type as attribute instead of element text
static const size_t | XF_valueTypeAsAttribute
| write: encode value type as attribute instead of element text
static const size_t | XF_templateIdentifierAsAttribute
| write: encode template identifier as attribute instead of element text
static const size_t | XF_useDcmsrNamespace
| write: add DCMSR namespace declaration to the XML output
static const size_t | XF_addSchemaReference
| write: add Schema reference to XML document
static const size_t | XF_validateSchema
| read: validate content of XML document against Schema
static const size_t | XF_templateElementEnclosesItems
| read/write: template identification element encloses content items
static const size_t | XF_addCommentsForIncludedTemplate
| write: add comments with details at beginning/end of included template (might be useful for debugging purposes)
static const size_t | XF_acceptEmptyStudySeriesInstanceUID
| read: accept empty Study/Series/SOP Instance UID attribute values (must be filled later)
static const size_t | XF_encodeEverythingAsAttribute
| shortcut: combines all XF_xxxAsAttribute write flags (see above)
static const size_t | PF_printItemPosition
| print item position ("1.2.3") instead of line indentation
static const size_t | PF_shortenLongItemValues
| shorten long item value (e.g. long texts)
static const size_t | PF_printSOPInstanceUID
| print SOP instance UID of referenced objects
static const size_t | PF_printConceptNameCodes
| print coding scheme designator/version and code value of concept names
static const size_t | PF_printNoDocumentHeader
| print no general document information (header)
static const size_t | PF_printTemplateIdentification
| print template identification (TID and mapping resource)
static const size_t | PF_useANSIEscapeCodes
| use ANSI escape codes for output
static const size_t | PF_printLongSOPClassName
| print long SOP class name of referenced objects (default: short name for images)
static const size_t | PF_printSOPClassUID
| print SOP class UID of referenced objects (instead of the name)
static const size_t | PF_printInvalidCodes
| print code triple for invalid codes (instead of the text "invalid code")
static const size_t | PF_printNodeID
| print node ID at the beginning of each line (might be useful for debugging purposes)
static const size_t | PF_indicateEnhancedEncodingMode
| indicate with a "*" that the "enhanced encoding mode" is used for codes
static const size_t | PF_printAnnotation
| print annotation of a content item (optional, e.g. user-defined information)
static const size_t | PF_hideIncludedTemplateNodes
| do not print internal "included template" nodes (position counter is still increased)
static const size_t | PF_dontCountIncludedTemplateNodes
| do not count internal "included template" nodes (only with PF_hideIncludedTemplateNodes)
static const size_t | PF_printEmptyCodes
| print text "empty code" for empty codes (instead of "invalid code")
static const size_t | PF_printAllCodes
| shortcut: print all codes (combines all PF_printXxxCodes flags, see above)
static const size_t | CM_updatePositionString
| update the position string using the node ID
static const size_t | CM_updateNodeID
| update the node ID using the position string
static const size_t | CM_resetReferenceTargetFlag
| reset the reference target flag for all nodes
static const size_t | CB_maskPrintFlags
| bit mask (filter) for valid print flags (see PF_xxx)
static const size_t | CB_maskReadFlags
| bit mask (filter) for valid read flags (see RF_xxx)

## Detailed Description

Interface class for content items.

This class allows to access the document tree nodes without using any pointers.

## Constructor & Destructor Documentation

## ◆ DSRContentItem()

DSRContentItem::DSRContentItem | ( | const DSRContentItem & | item | ) |

copy constructor.

Internally, the copy constructor of the respective tree node class is used, so the corresponding comments apply. This also means that the copy describes a separate content item, i.e. without relationships to other content items.

Parameters

  item | content item to be copied

## Member Function Documentation

## ◆ getAnnotationText()

const OFString& DSRContentItem::getAnnotationText | ( |  | ) | const

get annotation text.

The optional annotation text allows for labeling a content item with an arbitrary character string. This might be useful to navigate more easily within the document tree.

Applicable to all content items (optional).

Returns
  annotation text of current content item if valid, EmptyString otherwise

## ◆ getCodeValue() [1/2]

const DSRCodedEntryValue& DSRContentItem::getCodeValue | ( |  | ) | const

get code value.

Applicable to: CODE

Returns
  coded entry value of current content item if valid, EmptyCodedEntry otherwise

## ◆ getCodeValue() [2/2]

OFCondition DSRContentItem::getCodeValue | ( | DSRCodedEntryValue & | codeValue | ) | const

get copy of code value.

Applicable to: CODE

Parameters

  codeValue | variable where the copy should be stored

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getCodeValuePtr()

DSRCodedEntryValue* DSRContentItem::getCodeValuePtr | ( |  | ) |

get pointer to code value.

Applicable to: CODE

Returns
  pointer to code value of current content item if valid, NULL otherwise

## ◆ getCompositeReference() [1/2]

const DSRCompositeReferenceValue& DSRContentItem::getCompositeReference | ( |  | ) | const

get composite reference.

Applicable to: COMPOSITE

Returns
  reference value of current content item if valid, EmptyReference otherwise

## ◆ getCompositeReference() [2/2]

OFCondition DSRContentItem::getCompositeReference | ( | DSRCompositeReferenceValue & | referenceValue | ) | const

get copy of composite reference.

Applicable to: COMPOSITE

Parameters

  referenceValue | variable where the copy should be stored (cleared if an error occurs)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getCompositeReferencePtr()

DSRCompositeReferenceValue* DSRContentItem::getCompositeReferencePtr | ( |  | ) |

get pointer to composite reference.

Applicable to: COMPOSITE

Returns
  pointer to reference value of current content item if valid, NULL otherwise

## ◆ getConceptName() [1/2]

const DSRCodedEntryValue& DSRContentItem::getConceptName | ( |  | ) | const

get concept name.

Code describing the concept represented by this content item. Also conveys the value of document title and section headings in documents.

Applicable to all content items (by-value only).

Returns
  concept name value of current content item if valid, EmptyCodedEntry otherwise

## ◆ getConceptName() [2/2]

OFCondition DSRContentItem::getConceptName | ( | DSRCodedEntryValue & | conceptName | ) | const

get copy of concept name.

Code describing the concept represented by this content item. Also conveys the value of document title and section headings in documents.

Applicable to all content items (by-value only).

Parameters

  conceptName | variable where the copy should be stored (cleared if an error occurs)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getConceptNamePtr()

DSRCodedEntryValue* DSRContentItem::getConceptNamePtr | ( |  | ) |

get pointer to concept name.

Code describing the concept represented by this content item. Also conveys the value of document title and section headings in documents. Applicable to all content items (by-value only).

Returns
  pointer to concept name value of current content item if valid, NULL otherwise

## ◆ getContinuityOfContent()

E_ContinuityOfContent DSRContentItem::getContinuityOfContent | ( |  | ) | const

get continuity of content flag.

This flag specifies whether or not its contained content items (child nodes) are logically linked in a continuous textual flow, or are separate items.

Applicable to: CONTAINER

Returns
  continuity of content flag if successful, DSRTypes::COC_invalid otherwise

## ◆ getImageReference() [1/2]

const DSRImageReferenceValue& DSRContentItem::getImageReference | ( |  | ) | const

get image reference.

Applicable to: IMAGE

Returns
  image reference value of current content item if valid, EmptyImageReference otherwise

## ◆ getImageReference() [2/2]

OFCondition DSRContentItem::getImageReference | ( | DSRImageReferenceValue & | referenceValue | ) | const

get copy of image reference.

Applicable to: IMAGE

Parameters

  referenceValue | variable where the copy should be stored (cleared if an error occurs)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getImageReferencePtr()

DSRImageReferenceValue* DSRContentItem::getImageReferencePtr | ( |  | ) |

get pointer to image reference.

Applicable to: IMAGE

Returns
  pointer to image reference value of current content item if valid, NULL otherwise

## ◆ getNumericValue() [1/2]

const DSRNumericMeasurementValue& DSRContentItem::getNumericValue | ( |  | ) | const

get numeric value.

Applicable to: NUM

Returns
  numeric measurement value of current content item if valid, EmptyNumericMeasurement otherwise

## ◆ getNumericValue() [2/2]

OFCondition DSRContentItem::getNumericValue | ( | DSRNumericMeasurementValue & | numericValue | ) | const

get copy of numeric value.

Applicable to: NUM

Parameters

  numericValue | variable where the copy should be stored (cleared if an error occurs)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getNumericValuePtr()

DSRNumericMeasurementValue* DSRContentItem::getNumericValuePtr | ( |  | ) |

get pointer to numeric value.

Applicable to: NUM

Returns
  pointer to numeric value of current content item if valid, NULL otherwise

## ◆ getObservationDateTime()

const OFString& DSRContentItem::getObservationDateTime | ( |  | ) | const

get observation date/time.

This is the date and time on which this content item was completed. Might be empty if the date and time do not differ from the content date and time, see DSRDocument.

Applicable to all content items (by-value only, optional attribute).

Returns
  observation date/time of current content item if valid, EmptyString otherwise

## ◆ getObservationUID()

const OFString& DSRContentItem::getObservationUID | ( |  | ) | const

get observation unique identifier.

The UID represents the semantic content of the observation; an encoding of the same observation with the same context into another representation may use the same UID.

Applicable to all content items (by-value only, optional attribute).

Returns
  observation unique identifier of current content item if valid, EmptyString otherwise

## ◆ getReferencedNodeID()

size_t DSRContentItem::getReferencedNodeID | ( |  | ) | const

get ID of the referenced node.

Applicable to: by-reference relationships

Returns
  ID of the referenced node if valid, 0 otherwise

## ◆ getRelationshipType()

E_RelationshipType DSRContentItem::getRelationshipType | ( |  | ) | const

get relationship type.

Applicable to all content items.

Returns
  relationship type of current content item if valid, DSRTypes::RT_invalid otherwise

## ◆ getSpatialCoordinates() [1/2]

const DSRSpatialCoordinatesValue& DSRContentItem::getSpatialCoordinates | ( |  | ) | const

get spatial coordinates.

Applicable to: SCOORD

Returns
  spatial coordinates value of current content item if valid, EmptySpatialCoordinates otherwise

## ◆ getSpatialCoordinates() [2/2]

OFCondition DSRContentItem::getSpatialCoordinates | ( | DSRSpatialCoordinatesValue & | coordinatesValue | ) | const

get copy of spatial coordinates.

Applicable to: SCOORD

Parameters

  coordinatesValue | variable where the copy should be stored (cleared if an error occurs)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getSpatialCoordinates3D() [1/2]

const DSRSpatialCoordinates3DValue& DSRContentItem::getSpatialCoordinates3D | ( |  | ) | const

get spatial coordinates 3D.

Applicable to: SCOORD3D

Returns
  spatial coordinates 3D value of current content item if valid, EmptySpatialCoordinates3D otherwise

## ◆ getSpatialCoordinates3D() [2/2]

OFCondition DSRContentItem::getSpatialCoordinates3D | ( | DSRSpatialCoordinates3DValue & | coordinatesValue | ) | const

get copy of spatial coordinates 3D.

Applicable to: SCOORD3D

Parameters

  coordinatesValue | variable where the copy should be stored (cleared if an error occurs)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getSpatialCoordinates3DPtr()

DSRSpatialCoordinates3DValue* DSRContentItem::getSpatialCoordinates3DPtr | ( |  | ) |

get pointer to spatial coordinates 3D.

Applicable to: SCOORD3D

Returns
  pointer to spatial coordinates 3D value of current content item if valid, NULL otherwise

## ◆ getSpatialCoordinatesPtr()

DSRSpatialCoordinatesValue* DSRContentItem::getSpatialCoordinatesPtr | ( |  | ) |

get pointer to spatial coordinates.

Applicable to: SCOORD

Returns
  pointer to spatial coordinates value of current content item if valid, NULL otherwise

## ◆ getStringValue()

const OFString& DSRContentItem::getStringValue | ( |  | ) | const

get string value.

Applicable to: TEXT, DATETIME, DATE, TIME, UIDREF, PNAME

Returns
  string value of current content item if valid, EmptyString otherwise

## ◆ getTemplateIdentification() [1/2]

OFCondition DSRContentItem::getTemplateIdentification | ( | OFString & | templateIdentifier,
|  | OFString & | mappingResource
| ) |  | const

get template identifier and mapping resource.

This value pair identifies the template that was used to create this content item (and its children). According to the DICOM standard this is "required if a template was used to define the content of this Item, and the template consists of a single CONTAINER with nested content, and it is the outermost invocation of a set of nested templates that start with the same CONTAINER." The identification is valid if both values are either present (non-empty) or absent (empty).

Applicable to: CONTAINER

Parameters

  templateIdentifier | identifier of the template (might be empty)
  mappingResource | mapping resource that defines the template (might be empty)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getTemplateIdentification() [2/2]

OFCondition DSRContentItem::getTemplateIdentification | ( | OFString & | templateIdentifier,
|  | OFString & | mappingResource,
|  | OFString & | mappingResourceUID
| ) |  | const

get template identifier and mapping resource and optional mapping resource UID.

This value triple identifies the template that was used to create this content item (and its children). According to the DICOM standard, this is "required if a template was used to define the content of this Item, and the template consists of a single CONTAINER with nested content, and it is the outermost invocation of a set of nested templates that start with the same CONTAINER." The identification is valid if the first two values are either present (non-empty) or all three are absent (empty).

Applicable to: CONTAINER

Parameters

  templateIdentifier | identifier of the template (might be empty)
  mappingResource | mapping resource that defines the template (might be empty)
  mappingResourceUID | uniquely identifies the mapping resource (might be empty)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getTemporalCoordinates() [1/2]

const DSRTemporalCoordinatesValue& DSRContentItem::getTemporalCoordinates | ( |  | ) | const

get temporal coordinates.

Applicable to: TCOORD

Returns
  temporal coordinates value of current content item if valid, EmptyTemporalCoordinates otherwise

## ◆ getTemporalCoordinates() [2/2]

OFCondition DSRContentItem::getTemporalCoordinates | ( | DSRTemporalCoordinatesValue & | coordinatesValue | ) | const

get copy of temporal coordinates.

Applicable to: TCOORD

Parameters

  coordinatesValue | variable where the copy should be stored (cleared if an error occurs)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getTemporalCoordinatesPtr()

DSRTemporalCoordinatesValue* DSRContentItem::getTemporalCoordinatesPtr | ( |  | ) |

get pointer to temporal coordinates.

Applicable to: TCOORD

Returns
  pointer to temporal coordinates value of current content item if valid, NULL otherwise

## ◆ getValueType()

E_ValueType DSRContentItem::getValueType | ( |  | ) | const

get value type.

Applicable to all content items.

Returns
  value type of current content item if valid, DSRTypes::VT_invalid otherwise

## ◆ getWaveformReference() [1/2]

const DSRWaveformReferenceValue& DSRContentItem::getWaveformReference | ( |  | ) | const

get waveform reference.

Applicable to: WAVEFORM

Returns
  waveform reference value of current content item if valid, EmptyWaveformReference otherwise

## ◆ getWaveformReference() [2/2]

OFCondition DSRContentItem::getWaveformReference | ( | DSRWaveformReferenceValue & | referenceValue | ) | const

get copy of waveform reference.

Applicable to: WAVEFORM

Parameters

  referenceValue | variable where the copy should be stored (cleared if an error occurs)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ getWaveformReferencePtr()

DSRWaveformReferenceValue* DSRContentItem::getWaveformReferencePtr | ( |  | ) |

get pointer to waveform reference.

Applicable to: WAVEFORM

Returns
  pointer to waveform reference value of current content item if valid, NULL otherwise

## ◆ isEqual()

virtual OFBool DSRContentItem::isEqual | ( | const DSRContentItem & | item | ) | const
| virtual

check whether content items are "equal".

Two content items are regarded as equal if the comparison operator of the referenced document tree nodes says so.

Parameters

  item | content item that should be compared to the current one

Returns
  OFTrue if both content items are equal, OFFalse otherwise

## ◆ isMarked()

OFBool DSRContentItem::isMarked | ( |  | ) | const

check for mark flag.

Applicable to all content items.

Returns
  OFTrue if current content item is marked, OFFalse otherwise

## ◆ isNotEqual()

virtual OFBool DSRContentItem::isNotEqual | ( | const DSRContentItem & | item | ) | const
| virtual

check whether content items are "not equal".

Two content items are regarded as not equal if the comparison operator of the referenced document tree nodes says so.

Parameters

  item | content item that should be compared to the current one

Returns
  OFTrue if both content items are not equal, OFFalse otherwise

## ◆ isValid()

OFBool DSRContentItem::isValid | ( |  | ) | const

check for validity/completeness.

Applicable to all content items.

Returns
  OFTrue if current content item is valid, OFFalse otherwise

## ◆ setAnnotationText()

OFCondition DSRContentItem::setAnnotationText | ( | const OFString & | annotationText | ) | const

set annotation text.

The optional annotation text allows for labeling a content item with an arbitrary character string. This might be useful to navigate more easily within the document tree.

Applicable to all content items (optional).

Parameters

  annotationText | value to be set (might be an empty string)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setCodeValue()

OFCondition DSRContentItem::setCodeValue | ( | const DSRCodedEntryValue & | codeValue,
|  | const OFBool | check = `OFTrue`
| ) |  |

set code value.

Applicable to: CODE

Parameters

  codeValue | value to be set
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setCompositeReference()

OFCondition DSRContentItem::setCompositeReference | ( | const DSRCompositeReferenceValue & | referenceValue,
|  | const OFBool | check = `OFTrue`
| ) |  |

set composite reference.

Applicable to: COMPOSITE

Parameters

  referenceValue | value to be set
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setConceptName()

OFCondition DSRContentItem::setConceptName | ( | const DSRCodedEntryValue & | conceptName,
|  | const OFBool | check = `OFTrue`
| ) |  |

set concept name.

Code describing the concept represented by this content item. Also conveys the value of document title and section headings in documents.

Applicable to all content items (by-value only, optional/conditional for some value types).

Parameters

  conceptName | value to be set
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setContinuityOfContent()

OFCondition DSRContentItem::setContinuityOfContent | ( | const E_ContinuityOfContent | continuityOfContent,
|  | const OFBool | check = `OFTrue`
| ) |  |

set continuity of content flag.

This flag specifies whether or not its contained content items (child nodes) are logically linked in a continuous textual flow, or are separate items.

Applicable to: CONTAINER

Parameters

  continuityOfContent | value to be set (should be different from DSRTypes::COC_invalid)
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setImageReference()

OFCondition DSRContentItem::setImageReference | ( | const DSRImageReferenceValue & | referenceValue,
|  | const OFBool | check = `OFTrue`
| ) |  |

set image reference.

Applicable to: IMAGE

Parameters

  referenceValue | value to be set
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setMark()

void DSRContentItem::setMark | ( | const OFBool | flag | ) |

mark/unmark item.

Applicable to all content items.

Parameters

  flag | mark item if OFTrue, unmark otherwise

## ◆ setNumericValue()

OFCondition DSRContentItem::setNumericValue | ( | const DSRNumericMeasurementValue & | numericValue,
|  | const OFBool | check = `OFTrue`
| ) |  |

set numeric value.

Applicable to: NUM

Parameters

  numericValue | value to be set
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setObservationDateTime()

OFCondition DSRContentItem::setObservationDateTime | ( | const OFString & | observationDateTime,
|  | const OFBool | check = `OFTrue`
| ) |  |

set observation date/time.

This is the date and time on which this content item was completed. Might be empty if the date and time do not differ from the content date and time, see DSRDocument. Please use the correct DICOM format (VR=DT).

Applicable to all content items (by-value only).

Parameters

  observationDateTime | value to be set (might be an empty string)
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setObservationUID()

OFCondition DSRContentItem::setObservationUID | ( | const OFString & | observationUID,
|  | const OFBool | check = `OFTrue`
| ) |  |

set observation unique identifier.

The UID represents the semantic content of the observation; an encoding of the same observation with the same context into another representation may use the same UID. Please use the correct DICOM format (VR=UI).

Applicable to all content items (by-value only).

Parameters

  observationUID | value to be set (might be an empty string)
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setSpatialCoordinates()

OFCondition DSRContentItem::setSpatialCoordinates | ( | const DSRSpatialCoordinatesValue & | coordinatesValue,
|  | const OFBool | check = `OFTrue`
| ) |  |

set spatial coordinates.

Applicable to: SCOORD

Parameters

  coordinatesValue | value to be set
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setSpatialCoordinates3D()

OFCondition DSRContentItem::setSpatialCoordinates3D | ( | const DSRSpatialCoordinates3DValue & | coordinatesValue,
|  | const OFBool | check = `OFTrue`
| ) |  |

set spatial coordinates 3D.

Applicable to: SCOORD3D

Parameters

  coordinatesValue | value to be set
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setStringValue()

OFCondition DSRContentItem::setStringValue | ( | const OFString & | stringValue,
|  | const OFBool | check = `OFTrue`
| ) |  |

set string value.

Please use the correct format for the string value depending on the corresponding content item (value type).

Applicable to: TEXT, DATETIME, DATE, TIME, UIDREF, PNAME

Parameters

  stringValue | value to be set
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setTemplateIdentification()

OFCondition DSRContentItem::setTemplateIdentification | ( | const OFString & | templateIdentifier,
|  | const OFString & | mappingResource,
|  | const OFString & | mappingResourceUID = `""`,
|  | const OFBool | check = `OFTrue`
| ) |  |

set template identifier and mapping resource.

The identification is valid if the first two values are either present (non-empty) or all three values are absent (empty). See getTemplateIdentification() for details. Please use the correct DICOM format for all values (VR=CS,CS,UI).

Applicable to: CONTAINER

Parameters

  templateIdentifier | identifier of the template to be set
  mappingResource | mapping resource that defines the template
  mappingResourceUID | uniquely identifies the mapping resource (optional)
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setTemporalCoordinates()

OFCondition DSRContentItem::setTemporalCoordinates | ( | const DSRTemporalCoordinatesValue & | coordinatesValue,
|  | const OFBool | check = `OFTrue`
| ) |  |

set temporal coordinates.

Applicable to: TCOORD

Parameters

  coordinatesValue | value to be set
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setTreeNode()

void DSRContentItem::setTreeNode | ( | DSRDocumentTreeNode * | node | ) |
| inline protected

set internal tree node pointer (protected)

Parameters

  node | pointer to the document tree node (content item)

## ◆ setWaveformReference()

OFCondition DSRContentItem::setWaveformReference | ( | const DSRWaveformReferenceValue & | referenceValue,
|  | const OFBool | check = `OFTrue`
| ) |  |

set waveform reference.

Applicable to: WAVEFORM

Parameters

  referenceValue | value to be set
  check | if enabled, check value for validity before setting it

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ swap()

void DSRContentItem::swap | ( | DSRContentItem & | item | ) |
| protected

fast, non-throwing swap function.

The time complexity of this function is constant.

Parameters

  item | content item to swap with

## Member Data Documentation

## ◆ EmptyCodedEntry

const DSRCodedEntryValue DSRContentItem::EmptyCodedEntry
| static private

empty coded entry value.

Used as default return value for getCodeValue() and getConceptName()

## ◆ EmptyCompositeReference

const DSRCompositeReferenceValue DSRContentItem::EmptyCompositeReference
| static private

empty composite reference value.

Used as default return value for getCompositeReference()

## ◆ EmptyImageReference

const DSRImageReferenceValue DSRContentItem::EmptyImageReference
| static private

empty image reference value.

Used as default return value for getImageReference()

## ◆ EmptyNumericMeasurement

const DSRNumericMeasurementValue DSRContentItem::EmptyNumericMeasurement
| private

empty numeric measurement value.

Used as default return value for getNumericValue(). A static member variable (as for the other values below) cannot be used because this class contains members that again contain OFCondition instances that cannot be defined before the main() function starts.

## ◆ EmptySpatialCoordinates

const DSRSpatialCoordinatesValue DSRContentItem::EmptySpatialCoordinates
| static private

empty spatial coordinates value.

Used as default return value for getSpatialCoordinates()

## ◆ EmptySpatialCoordinates3D

const DSRSpatialCoordinates3DValue DSRContentItem::EmptySpatialCoordinates3D
| static private

empty spatial coordinates 3D value.

Used as default return value for getSpatialCoordinates3D()

## ◆ EmptyString

const OFString DSRContentItem::EmptyString
| static private

empty string value.

Used as default return value for getStringValue()

## ◆ EmptyTemporalCoordinates

const DSRTemporalCoordinatesValue DSRContentItem::EmptyTemporalCoordinates
| static private

empty temporal coordinates value.

Used as default return value for getTemporalCoordinates()

## ◆ EmptyWaveformReference

const DSRWaveformReferenceValue DSRContentItem::EmptyWaveformReference
| static private

empty waveform reference value.

Used as default return value for getWaveformReference()

The documentation for this class was generated from the following file:

- dcmsr/include/dcmtk/dcmsr/dsrcitem.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1